using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;
using System.Drawing;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.MapUnit = GeographyUnit.Meter;

                Proj4Projection proj4 = new Proj4Projection();
                proj4.InternalProjectionParametersString = Proj4Projection.GetDecimalDegreesParametersString();
                proj4.ExternalProjectionParametersString = Proj4Projection.GetGoogleMapParametersString();
                ShapeFileFeatureSource featureSource = new ShapeFileFeatureSource(MapPath("~/SampleData/USA/quksigx020.shp"));
                featureSource.CustomColumnFetch += new EventHandler<CustomColumnFetchEventArgs>(featureSource_CustomColumnFetch);
                featureSource.Projection = proj4;

                HeatLayer heatLayer = new HeatLayer(featureSource);
                HeatStyle hs = new HeatStyle();
                hs.IntensityColumnName = "intensityColumnName";
                hs.IntensityRangeStart = 1;
                hs.IntensityRangeEnd = 10;
                hs.Alpha = 180;
                hs.PointRadius = 60;
                hs.PointRadiusUnit = DistanceUnit.Kilometer;
                heatLayer.HeatStyle = hs;
                heatLayer.FeatureSource.Projection = proj4;

                LayerOverlay heatlayerOverlay = new LayerOverlay();
                heatlayerOverlay.IsBaseOverlay = false;
                heatlayerOverlay.Layers.Add(heatLayer);
                heatlayerOverlay.Redraw();
                heatlayerOverlay.IsVisible = true;
                heatlayerOverlay.IsVisibleInOverlaySwitcher = true;

                Map1.CustomOverlays.Add(heatlayerOverlay);
                BingMapsOverlay b = new BingMapsOverlay();
                b.MapType = BingMapsStyle.Hybrid;
                b.IsBaseOverlay = true;
                Map1.CustomOverlays.Add(b);
            }
        }
        private void featureSource_CustomColumnFetch(object sender, CustomColumnFetchEventArgs e)
        {
            e.ColumnValue = e.Id;
        }
        protected void Button1_Click(object sender, EventArgs e)
        {
            Bitmap bmp = Map1.GetBitmap(400, 400);
            bmp.Save(@"C:\temp\c.png");
        } 
    }
}
